gtkmm: Gtk::IconFactory Class Reference

gtkmm 3.24.2

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gtk::IconFactory Class Reference

`#include <gtkmm/iconfactory.h>`

Inheritance diagram for Gtk::IconFactory:
[legend]

## Public Member Functions
| IconFactory (IconFactory&& src) noexcept
IconFactory& | operator= (IconFactory&& src) noexcept
| ~IconFactory () noexcept override
GtkIconFactory* | gobj ()
| Provides access to the underlying C GObject. More...
const GtkIconFactory* | gobj () const
| Provides access to the underlying C GObject. More...
GtkIconFactory* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
void | add (const Gtk::StockID& stock_id, const Glib::RefPtr< IconSet >& icon_set)
| Adds the given icon_set to the icon factory, under the name stock_id. More...
void | add_default ()
| Adds an icon factory to the list of icon factories searched by Gtk::Style::lookup_icon_set(). More...
void | remove_default ()
| Removes an icon factory from the list of default icon factories. More...
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
void | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void > &slot)
void | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void > &&slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, const sigc::slot< void > &slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, sigc::slot< void > &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< IconFactory > | create ()

## Protected Member Functions
| IconFactory ()
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gtk::IconFactory > | wrap (GtkIconFactory* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

Deprecated:
  Use Gtk::IconTheme instead.

## Constructor & Destructor Documentation

## ◆ IconFactory() [1/2]

Gtk::IconFactory::IconFactory | ( | IconFactory&& | src | ) |
| noexcept

## ◆ ~IconFactory()

Gtk::IconFactory::~IconFactory | ( |  | ) |
| overridenoexcept

## ◆ IconFactory() [2/2]

Gtk::IconFactory::IconFactory | ( |  | ) |
| protected

## Member Function Documentation

## ◆ add()

void Gtk::IconFactory::add | ( | const Gtk::StockID& | stock_id,
|  | const Glib::RefPtr< IconSet >& | icon_set
| ) |  |

Adds the given icon_set to the icon factory, under the name stock_id.

stock_id should be namespaced for your application, e.g. “myapp-whatever-icon”. Normally applications create a Gtk::IconFactory, then add it to the list of default factories with add_default(). Then they pass the stock_id to widgets such as Gtk::Image to display the icon. Themes can provide an icon with the same name (such as "myapp-whatever-icon") to override your application’s default icons. If an icon already existed in factory for stock_id, it is unreferenced and replaced with the new icon_set.

Deprecated: 3.10: Use Gtk::IconTheme instead.

Parameters

  stock_id | Icon name.
  icon_set | Icon set.

## ◆ add_default()

void Gtk::IconFactory::add_default | ( |  | ) |

Adds an icon factory to the list of icon factories searched by Gtk::Style::lookup_icon_set().

This means that, for example, the Image::Image(const Gtk::StockID& stock_id, IconSize size) constructor will be able to find icons in factory. There will normally be an icon factory added for each library or application that comes with icons. The default icon factories can be overridden by themes.

## ◆ create()

static Glib::RefPtr<IconFactory> Gtk::IconFactory::create | ( |  | ) |
| static

## ◆ get_type()

static GType Gtk::IconFactory::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GtkIconFactory* Gtk::IconFactory::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkIconFactory* Gtk::IconFactory::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GtkIconFactory* Gtk::IconFactory::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ operator=()

IconFactory& Gtk::IconFactory::operator= | ( | IconFactory&& | src | ) |
| noexcept

## ◆ remove_default()

void Gtk::IconFactory::remove_default | ( |  | ) |

Removes an icon factory from the list of default icon factories.

Not normally used; you might use it for a library that can be unloaded or shut down.

Deprecated: 3.10: Use Gtk::IconTheme instead.

## Friends And Related Function Documentation

## ◆ wrap()

Glib::RefPtr< Gtk::IconFactory > wrap | ( | GtkIconFactory * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.